library stl_generater;
import 'dart:collection';
part 'stl_block.dart';
part 'stl_function_block.dart';
part 'stl_converter.dart';
part 'stl_head.dart';
part 'stl_network.dart';
part 'templates.dart';

const String FC = 'function';
const String DB = 'data block';
const String FB = 'function block';
const String PCODE_END='@EndGoosyGenerater';
const String PCODE_BEGIN='@GoosyGenerater';

class StlGenerater extends StlConverter{
  List<StlBlock> blocks;
  final Map<String,String> _template;

  String get stlCode {
    if(!_valid)return '';
    List<String> codes = <String>[];
    blocks.forEach((block){
      codes.add(block.stlCode);
    });
    return codes.join('\n\n\n');
  }
  String get pCode {
    if(!_valid)return '';
    List<String> codes = <String>[];
    blocks.forEach((block){
      codes.add(block.pCode);
    });
    return codes.join('\n\n\n');
  }

  StlGenerater(Template this._template);

  void parse(String text){
    _valid=false;
    blocks = <StlBlock>[];
    var regBegin = new RegExp(r'(^|\n)[ \f\t\v]*(//)?[ \f\t\v]*''$PCODE_BEGIN'r'[ \f\t\v]*'); // 开头标志
    var regEnd = new RegExp(r'\n[ \f\t\v]*(//)?[ \f\t\v]*''$PCODE_END');                // 结尾标志
    var block1=text.split(regEnd);
    block1.removeLast();
    block1.forEach((String str){
      var block2 = str.split(regBegin);
      if(block2.length<2)return;
      var body=block2[1];
      var block = new StlFunctionBlock(body,_template);
      if(block.isValid){
        _valid=true;
        blocks.add(block);
      }
    });
  }
}


