part of stl_generater;

abstract class StlHead extends StlConverter {
  final StlBlock block;
  String _blockName,_title,_comment;
  String get name=>_blockName;
  String get title=>_title==null?'':_title;
  String get comment=>_comment==null?'':_comment;
  StlHead(this.block);
}

class StlFunctionHead extends StlHead{
  String get pCode => '$PCODE_BEGIN '
      'function:$_blockName'
      "${_title==null?'':', title:$_title'}"
      "${_comment==null?'':'\n$_comment'}";
  String get stlCode {
    //bug:
    //reg=new RegExp(r'^', multiLine: true)
    //str.replaceAll(reg, '// ')
    var reg = new RegExp(r'\n', multiLine: true);//
    var headcomment = '// 所有@开头的行勿删，用于程序自动生成\n// ' + block.pCode.replaceAll(reg,'\n// ');
    var headcode=block.template['head']
      .replaceAll(r'$function$',_blockName)
      .replaceAll(r'$title$',title)
      .replaceAll(r'$comment$',headcomment);
    return headcode;
  }
  StlFunctionHead(String headStr, StlBlock block):super(block){
    // @GoosyGenerater function:FC块名, title:FC块标题, comment:FC块说明，可多行
    RegExp reg = new RegExp(
        r'^function[ \f\t\v]*:[ \f\t\v]*([^ \s,:]+)[ \f\t\v]*(?:,[ \f\t\v]*title[ \f\t\v]*:[ \f\t\v]*([^\r\n]+))?'  // 第一行
        r'(?:\n([\w\W]*))?$');         // 第一行后为comment
    Match match = reg.firstMatch(headStr);
    if (match==null) {
      return;
    }
    _blockName=match.group(1);
    _title=match.group(2);
    _comment=match.group(3);
    reg=new RegExp(r'^([ \f\t\v]*// ?)', multiLine: true);
    if(_comment!=null)_comment=_comment.replaceAll(reg,'');
    
    _valid = true;
  }
}