part of stl_generater;

class StlNetwork extends StlConverter {
  String _template,_stlCode,_pCode;
  String get pCode => _pCode;
  String get stlCode => _stlCode;
  Map<String,String> attributes=<String,String>{};
  final StlBlock block;

  StlNetwork(String lineStr, this.block){
    // @GoosyGenerater function:FC块名, title:FC块标题, comment:FC块说明，可多行

    RegExp reg = new RegExp(
        r'^[ \f\t\v]*([^\n\r]*?)'                        // comment之前的不允许换行
        r'(?:,[ \f\t\v]*comment[ \f\t\v]*:([\w\W]*))?$'  // comment之后的可换行
    );
    Match match = reg.firstMatch(lineStr);
    if (match==null) {
      return;
    }
    lineStr=match.group(1);
    var comment=match.group(2);

    reg=new RegExp(r'^([ \f\t\v]*\// ?)', multiLine: true);
    if(comment!=null)comment=comment.replaceAll(reg,'').trim();
    
    var attrs=lineStr.split(',');
    var variant = attrs.removeAt(0).trim();
    if (variant=='') return;
    attributes['variant']=variant;
    _pCode='@variant:$variant';
    attrs.forEach((String attr){
      var pair=attr.split(':');
      if(pair.length<2)return;//没有:分隔
      var key=pair[0].trim();
      var value=pair[1].trim();
      _pCode += ', $key:$value';
      if(key=="piw") {
        if(new RegExp(r'^\d+$').hasMatch(value))value="PIW  $value";
        else value='"$value"';
      }
      attributes[key]=value;
    });
    _pCode += comment==null?'':', comment:$comment';
    _stlCode=block.template['network'];
    attributes['comment']=comment==null?variant:comment;
    attributes['title']=attributes.containsKey('title')?attributes['title']:variant;
    attributes['piw']=attributes.containsKey('piw')?attributes['piw']:'"$variant"';
    attributes['range']=attributes.containsKey('range')?attributes['range']:variant;
    //attributes['sn'] = ((sn++)+1000).toString().substring(1); //000格式
    attributes.forEach( (key,value){
      _stlCode=_stlCode.replaceAllMapped("\$$key\$",(Match m){
        return value;
      });
    });
    _valid = true;
  }
}