part of stl_generater;

typedef void OnKey(String key, String value);
class Template<K, V> extends HashMap<K, V> {
  Template():super();
  factory Template.from(Map<K, V> other)=>new Template<K,V>()..addAll(other);
  Map<String,OnKey> _onPCodeKeys;
  Map<String,OnKey> _onStlKeys;
  
  onPKey(String name, OnKey onPCodeKey){ // add Listenner on pCode key find;
    _onPCodeKeys[name]=onPCodeKey;
  }
  onStlKey(String name, OnKey onStlKey){// add Listenner on StlCode key find;
    _onStlKeys[name]=onStlKey;
  }
}

Template scaleTemplate = new Template<String,String>.from({
'head':r"""
FUNCTION "$function$" : VOID
TITLE = $title$
$comment$
VERSION : 0.1

BEGIN
""",

'network':r"""
NETWORK
TITLE =$title$
//$comment$
      A(    ; 
      A     "Cbit0"; 
      =     L      0.0; 
      BLD   103; 
      CALL "SCALE" (
           IN                       := $piw$,
           HI_LIM                   := "ValueAI".rh$range$,
           LO_LIM                   := "ValueAI".rl$range$,
           BIPOLAR                  := L      0.0,
           RET_VAL                  := "ValueAI".er$variant$,
           OUT                      := "ValueAI".vl$variant$);
      A     BR; 
      )     ; 
      JNB   _$sn$;
      L     "ValueAI".vl$variant$;
      L     "ValueAI".fx$variant$;
      *R    ; 
      T     "ValueAI".vl$variant$;
_$sn$: NOP   0;
"""});

var valveScaleTemplate = <String,String>{
'head':r"""
FUNCTION "$function$" : VOID
TITLE = $title$
$comment$
VERSION : 0.1

BEGIN
""",
'network':r"""
NETWORK
TITLE =$title$
//$comment$
      CALL "ValveScale" (
           HI_limit                 := "Valve".rh$range$,
           LO_limit                 := "Valve".rl$range$,
           VG_in                    := $piw$,
           RET_VAL                  := "Valve".er$variant$,
           VG_out                   := "Valve".$variant$Pos);
      NOP   0;
"""};

var valveControlTemplate = <String,String>{
'head':r"""
FUNCTION "$function$" : VOID
TITLE = $title$
$comment$
VERSION : 0.1

BEGIN
""",
'network':r"""
NETWORK
TITLE =$title$
//$comment$
      A     "$variant$OP";
      =     L      0.0; 
      BLD   103; 
      A     "$variant$CP";
      =     L      0.1; 
      BLD   103; 
      A     "$variant$RL";
      =     L      0.2; 
      BLD   103; 
      A     "$variant$ER";
      =     L      0.3; 
      BLD   103; 
      CALL "ValveControl" (
           iOP                      := L      0.0,
           iCP                      := L      0.1,
           iRL                      := L      0.2,
           iER                      := L      0.3,
           i2POS                    := "Valve".$variant$Pos2,
           iPOS                     := "Valve".$variant$Pos,
           i_P                      := "Valve".$variant$PosCmd,
           i_O                      := "Valve".$variant$OpenCmd,
           i_C                      := "Valve".$variant$CloseCmd,
           i_S                      := "Valve".$variant$StopCmd,

           o_OS                     := "$variant$OS",
           o_CS                     := "$variant$CS");
           f_O                      :="Valve".$variant$Openning,
           f_C                      :="Valve".$variant$Closing,
           f_D                      :="Valve".$variant$Disable);
      NOP   0; 
"""};

var valveControl2Template = <String,String>{
'head':r"""
FUNCTION "$function$" : VOID
TITLE = $title$
$comment$
VERSION : 0.1

BEGIN
""",
'network':r"""
NETWORK
TITLE =$title$
//$comment$
      A     "$variant$OP";
      =     L      0.0;
      BLD   103;
      A     "$variant$CP";
      =     L      0.1;
      BLD   103;
      A     "$variant$R";
      =     L      0.2;
      BLD   103;
      A     "$variant$OER";
      =     L      0.3;
      BLD   103;
      A     "$variant$CER";
      =     L      0.4;
      BLD   103;
      CALL "ValveCtrl2" (
           iOP                      := L      0.0,
           iCP                      := L      0.1,
           iRL                      := L      0.2,
           iOER                     := L      0.3,
           iCER                     := L      0.4,
           i2POS                    := "Valve".$variant$Pos2,
           iPOS                     := "Valve".$variant$Pos,
           delayTimer               := T    $timer$,
           i_P                      := "Valve".$variant$PosCmd,
           i_O                      := "Valve".$variant$OpenCmd,
           i_C                      := "Valve".$variant$CloseCmd,
           i_S                      := "Valve".$variant$StopCmd,
           o_OS                     := "$variant$OS",
           o_SS                     := "$variant$SS",
           o_CS                     := "$variant$CS",
           o_ER                     := "Valve".$variant$ER,
           f_O                      := "Valve".$variant$Openning,
           f_C                      := "Valve".$variant$Closing,
           f_D                      := "Valve".$variant$Disable);
      NOP   0;
"""
};

